;author Ecronika
;script Autocorrecter
;version 0.8.1
;public autocorrect, _dac.get, _dac.version

#_dac.command on
alias autocorrect {
  ;syntax /autocorrect
  ;description Opens the Autocorrect Preferences.
  ;returns null

  if (!$isid) { _dac.dialog }
}
#_dac.command end
alias _dac.get {
  ;syntax $_dac.get(text)
  ;description Returns the corrected Text (if enabled).
  ;returns string

  if   ($_dac.st(enable)) { return $_dac.doit($1-) }
  else                    { return $1-             }
}
alias _dac.version {
  ;syntax $_dac.version
  ;description Returns the version of Autocorrecter.
  ;returns number

  return 0.8.1
}
alias -l _dac.files { return $+(",$scriptdir,$1,") }
alias -l _dac.mdx { return $dll($_dac.files(mdx.dll),$1,$2-) }
alias -l _dac.st {
  if   ($isid) { return $hget(_dac,$$1) }
  else         {
    hadd -m _dac $1 $$2-
    return
  }
}
alias -l _dac.dialog {
  if   ($dialog(_dac.setup)) { dialog -v _dac.setup            }
  else                       { dialog -m _dac.setup _dac.setup }
}
alias -l _dac.addedit {
  _dac.st addedit $1
  $dialog(_dac.addedit,_dac.addedit,-4)
  did -i _dac.setup 1 1 headerdims autoheader:all
}
alias -l _dac.doit {
  var %text
  tokenize 32 $1-
  while ($1 != $null) {
    if   ($hget(_dac,$+(replace_,$1))) { %text = %text $ifmatch }
    else                               { %text = %text $1       }

    tokenize 32 $2-
  }
  return %text
}
alias -l _dac.setup {
  if ($isid) {

    if   ($1 isnum) { var %sel = $1                     }
    else            { var %sel = $did(_dac.setup,1).sel }

    var %line    = $gettok($did(_dac.setup,1,%sel),2-,32)
    var %replace = $gettok($gettok(%line,1,9),5-,32)
    var %with    = $gettok($gettok(%line,2,9),5-,32)

    return %replace $+ $chr(4) $+ %with
  }
  elseif ($1 == fill) {
    var %win = @_dac.autocorrect
    close -@ %win
    window -hls %win
    var %n = $hmatch(_dac,replace_*,0)
    while (%n) {
      var %item = $hmatch(_dac,replace_*,%n)
      aline %win $remove(%item,replace_) $+ $chr(9) $+ $_dac.st(%item)
      dec %n
    }
    filter -wo %win _dac.setup 1
    close -@ %win
  }
}
menu menubar {
  &Autocorrecter
  .&Setup:_dac.dialog
  .-
  .&Webboard:.url -n http://webboard.defcon-one-script.de/viewforum.php?f=9
  .&About
  .-
  .&Unload:.unload -rs $nopath($script)
}
on *:input:#: {
  if ((!$_dac.st(enable)) || ($_dnc.version)) { return }
  var %_dac.commandchar = $readini($mircini,n,text,commandchar)
  if ($left($1,1) != %_dac.commandchar) {
    msg $chan $_dac.doit($1-)
    haltdef
  }
}
on *:input:?: {
  if (!$_dac.st(enable)) || ($_dme.version > 1.0) { return }
  var %_dac.commandchar = $readini($mircini,n,text,commandchar)
  if ($left($1,1) != %_dac.commandchar) {
    msg $target $_dac.doit($1-)
    haltdef
  }
}
on *:start: {
  .disable #_dac.command
  if (!$isalias(autocorrect)) { .enable #_dac.command }
  hmake _dac 400
  if ($isfile($_dac.files(autocorrect.hsh))) { hload _dac $_dac.files(autocorrect.hsh) }
}
dialog -l _dac.setup {
  title "Autocorrecter Preferences [/autocorrect]"
  size -1 -1 141 184
  option dbu
  list 1, 10 25 121 115, size extsel
  check "Enable", 2, 5 5 34 10
  button "Add", 3, 10 145 37 12
  button "Edit", 4, 52 145 37 12
  button "Delete", 5, 94 145 37 12
  button "Cancel", 6, 99 167 37 12, cancel
  button "OK", 7, 57 167 37 12, ok
  box "", 8, 5 15 131 147
  text "", 9, 5 169 50 8
  menu "&Help", 10
  item "&Webboard", 11, 10
  item "&Check for Updates...", 12, 10
}
on *:dialog:_dac.setup:init:0: {
  if ($group(#_dac.command) == off) { dialog -t $dname Autocorrecter Setup }
  _dac.mdx SetMircVersion $version
  _dac.mdx MarkDialog $dname
  _dac.mdx SetControlMDX $dname 1 ListView headerdrag report rowselect showsel nosortheader single grid > $+($scriptdir,Views.mdx)
  did -i $dname 1 1 headerdims 100:1 100:2
  did -i $dname 1 1 headertext + 0 Replace $+ $chr(9) $+ + 0 With
  _dac.setup fill
  did -i $dname 1 1 headerdims autoheader:all
  if ($_dac.st(enable) == 1) { did -c $dname 2 }
  did -a _dac.setup 9 Version: $_dac.version
}
on *:dialog:_dac.setup:sclick:3: { _dac.addedit add }
on *:dialog:_dac.setup:sclick:4: { _dac.addedit edit }
on *:dialog:_dac.setup:sclick:5: { did -d $dname 1 $did(1).sel }
on *:dialog:_dac.setup:menu:11: { .url -n http://webboard.defcon-one-script.de/viewforum.php?f=9 }
on *:dialog:_dac.setup:menu:12: { .url -n $+(http://update.defcon-one-script.de/autocorrecter.php?version=,$_dac.version) }
on *:dialog:_dac.setup:sclick:7: {
  var %n = $did(1).lines
  hfree _dac
  hmake _dac %n
  while (%n > 1) {
    tokenize 4 $_dac.setup(%n)
    _dac.st $+(replace_,$1) $2
    dec %n
  }
  _dac.st enable $did(2).state
  hsave -o _dac $_dac.files(autocorrect.hsh)
}

dialog -l _dac.addedit {
  title "Autocorrect"
  size -1 -1 89 52
  option dbu
  text "Replace:", 1, 5 7 25 8
  edit "", 2, 35 5 50 10, autohs
  text "With:", 3, 5 22 25 8
  edit "", 4, 35 20 50 10, autohs
  button "OK", 5, 5 35 37 12, ok
  button "Cancel", 6, 47 35 37 12, cancel
}
on *:dialog:_dac.addedit:init:0: {
  var %mode = $_dac.st(addedit)
  if (%mode == edit) {
    var %sel = $did(_dac.setup,1).sel
    _dac.st editsel %sel
    var %line = $gettok($did(_dac.setup,1,%sel),2-,32)
    var %replace = $gettok($gettok(%line,1,9),5-,32)
    var %with = $gettok($gettok(%line,2,9),5-,32)
    did -a $dname 2 %replace
    did -a $dname 4 %with
  }
}
on *:dialog:_dac.addedit:sclick:5: {
  var %mode = $_dac.st(addedit)
  did $iif(%mode == edit,-o,-a) _dac.setup 1 $iif(%mode == edit,$_dac.st(editsel)) $did(2) $+ $chr(9) $+ $did(4)
}
